# Python imports

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# Application imports
from utils.widget_save_load_controller import WidgetSaveLoadController


class TextAreaWidget(WidgetSaveLoadController, Gtk.TextView):
    def __init__(self):
        super(TextAreaWidget, self).__init__()

        self.buffer = self.get_buffer()

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()

        self.show()


    def _setup_styling(self):
        ...

    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        ...

    def _load_widgets(self):
        ...

    def get_buffer_text(self):
        start, end = self.buffer.get_start_iter(), self.buffer.get_end_iter()
        return self.buffer.get_slice(start, end, True)

    def get_saveable_data(self):
        self.save_collection["data"] = self.get_buffer_text()
        self.save_collection["widget_type"] = str(type(self).__name__)
        return self.save_collection

    def set_saveable_data(self, data):
        self.save_collection = data
        self.load_saveable_data()

    def load_saveable_data(self):
        self.buffer.set_text(self.save_collection["data"])

    def new(self):
        widget = TextAreaWidget()
        widget.buffer.set_text("Lorem ipsum dolor")
        return widget
